apiVersion: apps/v1
kind: Deployment
metadata:
  name: db
spec:
  selector:
    matchLabels:
      app: mysql
      tier: mysql
      run: db
  strategy:
    type: Recreate  ##—terminates all the pods and replaces them with the new version.
  replicas: 1
  template:
    metadata:
      labels:
        app: mysql
        tier: mysql
        run: db
    spec:
      volumes:
        - name: mysql-pv-storage
          persistentVolumeClaim:
            claimName: pv-claim
      containers:
        - name: db
          image: mysql:8.0.19
          imagePullPolicy: "IfNotPresent"  ##Kubernetes will only pull the image when it does not already exist on the node.
          resources:
            requests:
              memory: "512Mi"
              cpu: "100m"
            limits:
              memory: "1024Mi"
              cpu: "500m"
          ports:
            - name: db-listner
              containerPort: 8070
              hostPort: 8070
          volumeMounts:
            - name: mysql-pv-storage
              mountPath: "/mountpoint"

          env:
            - name: MYSQL_DATABASE
              valueFrom:
                secretKeyRef:
                  name: db-secrets
                  key: MYSQL_DATABASE
            - name: DB_URL
              valueFrom:
                secretKeyRef:
                  name: db-secrets
                  key: DB_URL
            - name: MYSQL_USER
              valueFrom:
                secretKeyRef:
                  name: db-secrets
                  key: MYSQL_USER
            - name: MYSQL_ROOT_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: db-secrets
                  key: MYSQL_ROOT_PASSWORD

---
apiVersion: v1
kind: Service
metadata:
  name: mysql
  labels:
    app: mysql
spec:
  ports:
    - port: 3306
  selector:
    app: mysql
    tier: mysql ##e base of a web database application.
  